TITLE  MI  current

COMMENT
ENDCOMMENT

UNITS
  {
  (mA) = (milliamp)
  (mV) = (millivolt)
  (molar) = (1/liter)
  (mM) = (millimolar)
  (S) = (mho)
  (uS) = (microS)
  }
 
NEURON
  {
  SUFFIX mi
  NONSPECIFIC_CURRENT i
  RANGE gbar, g, vhalfm, vslopem, vhalfh, vslopeh,taum, i, e, minf
  }


PARAMETER 
  {
  gbar = 0 (uS/mm2)
  e = -10 (mV)
  taum = 5 (ms)
  }

ASSIGNED  
  {
  v (mV)
  minf
  g (uS/mm2)
  i (mA/cm2)
  vhalfm
  vslopem
  }

STATE
  {
  m
  }
 
BREAKPOINT
  {
  SOLVE state_change METHOD cnexp
  g = (m)*gbar
  i = (1e-4)*(g*(v-e))
  }

DERIVATIVE state_change
  {
  rates(v)
  m' = (minf-m)/taum
  }

INITIAL 
  {
  rates(v)
  m = minf
  }

PROCEDURE rates(v(mV)) 
  {  

  minf = 1 / (1 + exp( (v - vhalfm ) / vslopem) )
      
  }
