TITLE Na current

COMMENT
   
ENDCOMMENT

UNITS
  {
  (mA) = (milliamp)
  (mV) = (millivolt)
  (molar) = (1/liter)
  (mM) = (millimolar)
  (S) = (mho)
  (uS) = (microS)
  }
 
NEURON
  {
  SUFFIX na
  NONSPECIFIC_CURRENT i
  RANGE gbar, g, minf, hinf, taum, tauh, vslopem, vslopeh, vhalfm, vhalfh, i, e
  }

PARAMETER
  {
  gbar = 0 (uS/mm2)
  }

ASSIGNED
  {
  v (mV)
  e (mV)
  minf
  taum (ms)
  hinf
  tauh (ms)
  g (uS/mm2)
  i (mA/cm2)
  vhalfm (mV)
  vslopem (mV)
  vhalfh (mV)
  vslopeh (mV)
  }

STATE
  {
  m
  h
  }
 
BREAKPOINT
  {
  SOLVE state_change METHOD cnexp
  g = gbar*(m^3)*(h)
  i = (1e-4)*(g*(v-e))
  }

DERIVATIVE state_change
  {
  rates(v)  
  m' = (minf-m) / taum
  h' = (hinf-h) / tauh
  }

INITIAL 
  {
  rates(v)
  m = minf
  h = hinf
  }

PROCEDURE rates(v(mV)) 
  {
  minf = 1 / (1 + exp( (v - vhalfm) / vslopem ) ) 
  hinf = 1 / (1 + exp( (v - vhalfh) / vslopeh ) ) 
  }

  
